import asyncio

import pytest

from distributed.utils import AnyThreadEventLoopPolicy


# As found in:
# https://github.com/pytest-dev/pytest-asyncio/issues/168#issuecomment-703454710

@pytest.hookimpl(trylast=True)
def pytest_fixture_post_finalizer(fixturedef):
    if fixturedef.argname == "event_loop":
        # work around for https://github.com/pytest-dev/pytest-asyncio/issues/168
        oldloop = asyncio.get_event_loop_policy()
        if not isinstance(oldloop, AnyThreadEventLoopPolicy):
            newloop = AnyThreadEventLoopPolicy()
            # transfer existing eventloop to the new policy
            newloop.set_event_loop(oldloop.get_event_loop())
            asyncio.set_event_loop_policy(newloop)
